searchNodes=[{"type":"module","title":"Commanded.Middleware.Uniqueness","doc":"Documentation for Commanded.Middleware.Uniqueness.","ref":"Commanded.Middleware.Uniqueness.html"},{"type":"function","title":"Commanded.Middleware.Uniqueness.claim/4","doc":"Claims a key , value , owner , partition set or reports that this combination has already been claimed. If a key , value , owner , partition set has to be claimed and an old value for the given owner exists it releases first. If partition is ommited then default partition used.","ref":"Commanded.Middleware.Uniqueness.html#claim/4"},{"type":"function","title":"Commanded.Middleware.Uniqueness.claim_without_owner/3","doc":"Claims a key , value , partition set or reports that this combination has already been claimed. If partition is ommited then default partition used.","ref":"Commanded.Middleware.Uniqueness.html#claim_without_owner/3"},{"type":"function","title":"Commanded.Middleware.Uniqueness.default_partition/0","doc":"Returns default parition which is by default @Commanded.Middleware.Uniqueness","ref":"Commanded.Middleware.Uniqueness.html#default_partition/0"},{"type":"function","title":"Commanded.Middleware.Uniqueness.release/4","doc":"Releases a value record via key , value , owner , partition set","ref":"Commanded.Middleware.Uniqueness.html#release/4"},{"type":"function","title":"Commanded.Middleware.Uniqueness.release_by_owner/3","doc":"Releases a value record via key , owner , partition set","ref":"Commanded.Middleware.Uniqueness.html#release_by_owner/3"},{"type":"function","title":"Commanded.Middleware.Uniqueness.release_by_value/3","doc":"Releases a value record via key , value , partition set","ref":"Commanded.Middleware.Uniqueness.html#release_by_value/3"},{"type":"behaviour","title":"Commanded.Middleware.Uniqueness.Adapter","doc":"Provides uniqueness cache adapter behaviour. Define options in config/config.exs as: config :commanded_uniqueness_middleware, adapter : Commanded.Middleware.Uniqueness.Adapter.Cachex , # ttl: 60 minutes in seconds ttl : 60 * 60 , use_command_as_partition : true where: :adapter is an Uniqueness adapter implemented Commanded.Middleware.Uniqueness.Adapter behavior, :ttl is claimed value time-to-live, :use_command_as_partition should be set to use each command module name as partition. If neither this nor :partition option defined then Commanded.Middleware.Uniqueness value used as a partition name.","ref":"Commanded.Middleware.Uniqueness.Adapter.html"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.child_spec/0","doc":"Returns an adapter child_spec to inject into a supervisor tree","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:child_spec/0"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.claim/3","doc":"Claims an key , value , partition set or reports that this combination has already been claimed.","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:claim/3"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.claim/4","doc":"Claims an key , value , owner , partition set or reports that this combination has already been claimed. If an key , value , owner , partition set has to be claimed and an old value for the given owner exists it releases first.","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:claim/4"},{"type":"function","title":"Commanded.Middleware.Uniqueness.Adapter.get/0","doc":"Returns the current adapter or nil","ref":"Commanded.Middleware.Uniqueness.Adapter.html#get/0"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.release/4","doc":"Releases a value record via key , value , owner , partition set","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:release/4"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.release_by_owner/3","doc":"Releases a value record via key , owner , partition set","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:release_by_owner/3"},{"type":"callback","title":"Commanded.Middleware.Uniqueness.Adapter.release_by_value/3","doc":"Releases a value record via key , value , partition set","ref":"Commanded.Middleware.Uniqueness.Adapter.html#c:release_by_value/3"},{"type":"protocol","title":"Commanded.Middleware.Uniqueness.UniqueFields","doc":"","ref":"Commanded.Middleware.Uniqueness.UniqueFields.html"},{"type":"function","title":"Commanded.Middleware.Uniqueness.UniqueFields.unique/1","doc":"Returns unique fields for a command as a list of tuples as: {field_name :: atom() | list(atom), error_message :: String.t(), owner :: term, opts :: keyword()} , where opts might contain none, one or multiple options: ignore_case: true or ignore_case: [:email, :username] for multi-fields entities - binary-based fields are downcased before comparison :label - use this atom as error label :is_unique - (term, String.t(), term, keyword() -&gt; boolean()) :partition - use to set custom partition name :no_owner - if true then ignore owner and check field_name - field_value pair uniqueness in a partition scope. release_by_value/3 must be used to release key-value pair in such case. :no_owner option has sense when it is necessary to ensure uniquenesses in embedded structs.","ref":"Commanded.Middleware.Uniqueness.UniqueFields.html#unique/1"},{"type":"type","title":"Commanded.Middleware.Uniqueness.UniqueFields.t/0","doc":"All the types that implement this protocol.","ref":"Commanded.Middleware.Uniqueness.UniqueFields.html#t:t/0"},{"type":"extras","title":"Getting started","doc":"Getting started","ref":"getting-started.html"},{"type":"extras","title":"Getting started - Introduction","doc":"A Commanded middleware for checking certain values uniqueness during commands dispatch. Might be useful as a short-term unique values cache before subsequent events persisted and projected. Based on the Ben Smith 's idea described in his &quot;Building Conduit&quot; book .","ref":"getting-started.html#introduction"},{"type":"extras","title":"Getting started - Installation","doc":"Add commanded_uniqueness_middleware to your list of dependencies in mix.exs : def deps do [ { :commanded_uniqueness_middleware , &quot;~&gt; 0.7.0&quot; } ] end","ref":"getting-started.html#installation"},{"type":"extras","title":"Getting started - Configuration","doc":"Define options in config/config.exs as: config :commanded_uniqueness_middleware , adapter : Commanded.Middleware.Uniqueness.Adapter.Cachex , # ttl: 60 minutes in seconds ttl : 60 * 60 , use_command_as_partition : false or config :commanded_uniqueness_middleware , adapter : Commanded.Middleware.Uniqueness.Adapter.Nebulex , nebulex_cache : YourApp.Nebulex.Uniqueness.Cache , # ttl: 60 minutes in seconds ttl : 60 * 60 , use_command_as_partition : false where: :adapter is an Uniqueness adapter implemented Commanded.Middleware.Uniqueness.Adapter behavior, :nebulex_cache is a module with Nebulex.Cache behaviour implemented in your application, :ttl is claimed value time-to-live, :use_command_as_partition should be set to true to use each command module name as partition. Use with caution! If neither this nor Unique protocol :partition option defined then Commanded.Middleware.Uniqueness value used as a partition name.","ref":"getting-started.html#configuration"},{"type":"extras","title":"Getting started - Adapters","doc":"Two adapters currently exist: Based on Cachex Commanded.Middleware.Uniqueness.Adapter.Cachex Based on Nebula Commanded.Middleware.Uniqueness.Adapter.Nebulex Any adapter implementing Commanded.Middleware.Uniqueness.Adapter behavior can be used. Nebulex Nebulex adapter requires a custom Nebulex cache module. Please create it inside your application like: mix nbx . gen . cache - c YourApp.Nebulex.Uniqueness.Cache You can configure Nebulex caching strategy in the your application config and/or in the cache module itself. For details please check Nebulex documentation","ref":"getting-started.html#adapters"},{"type":"extras","title":"Getting started - Usage","doc":"Imagine you have an aggregate with a unique field value requirement, for example, it might be a :username field. You've got a new user and issue a RegisterUser command with SomeCoolUsername :name field value. The command successfully went through all checks and spawn a UserRegistered event but this event haven't been projected yet. At this very moment an another user wants to register with the same name, and as the previous event isn't projected you have no information that this user name has been taken. You can use Commanded.Middleware.Uniqueness to ensure that your system will not get into a conflict state in between two commands. It utilizes Elixir Protocol . You need to put middleware Commanded.Middleware.Uniqueness into your Commanded Router as described in Commanded docs . Then you need to define a Commanded.Middleware.Uniqueness.UniqueFields implementation for the specific command: defmodule MyApp.RegisterUser do defstruct [ :id , :name , :email ] end defimpl Commanded.Middleware.Uniqueness.UniqueFields , for : MyApp.RegisterUser do def unique ( % MyApp.RegisterUser { id : id } ) , do : [ { :name , &quot;has already been taken&quot; , id , ignore_case : true , is_unique : &amp; is_taken_externally? / 4 } ] def is_taken_externally? ( _field , value , _owner , _opts ) , do : ! String . starts_with? ( value , &quot;ExternallyTaken&quot; ) end At the first command dispatch the Uniqueness Middleware checks the :name field key - value pair is free and claims it for the given owner id. If you need to release previously claimed value with existing TTL you should use release/4 , release_by_owner/3 or release_by_value/3 adapter methods: defmodule MyApp.UserNameCacheHandler do use Commanded.Event.Handler , application : MyApp.App , name : &quot;UserNameCacheHandler&quot; alias MyApp.UserDeleted def handle ( % UserDeleted { id : id } , _metadata ) do :ok = Commanded.Middleware.Uniqueness . release_by_owner ( :name , id ) end end end To get to know behavior you can check modules documentation and tests (especially commands described in test/support ).","ref":"getting-started.html#usage"}]